//+------------------------------------------------------------------+
//|                                           Vilka indicator 1.3.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                       Ind_VilkaFractals_v1.3.mq4 |
//|                      Copyright  2009, Alexey Sleptsov (lekhach) |
//|                                             lekhach18@rambler.ru |
//|                                     Corrected by api Version 1.3 |
//|                                              p231970@hotmail.com |
//+------------------------------------------------------------------+
// ????????? ???????? ?? ????????? "????? ????????".
// ?????? 1.3 (api):
// 1. ??????? ??????? ?????? ?????, ????? ???????????? ? ????????? BarsToSearch ?????
// 2. ???????? ???????? ?? ???????? ??? ?????????? ????? ? ????? ? ???????????? ??????????
// 3. ?????????? ?????? ?????? ?????. ????? ?????? ?? ????????????.
// 3?. ????????? ????- ? ????? ???????? ?????.
// 4. ? ????????? ?????? ????????????? ??????????? ??? ???????? ??????????????????.
// 4?. ? ????? ?????????????????? ?????????? ????? ??-?? ??????????? ?????? ?? ????????? BarsToSearch ?????
// ?????? 1.2:
// 1. ????????? ??????? ???????? ???????? ??? ???????? ??????????.
// 2. ??????? ?????? ?????? ?? ????.
// 3. ????????? Alert.
// 4. ???????? FractalsTrue.
//--------------------------------------------------------------------
#property copyright "lekhach  2009"
#property link      "lekhach18@rambler.ru"
//--------------------------------------------------------------------
#property indicator_chart_window

#property indicator_buffers 2

#property indicator_color1 Yellow
#property indicator_width1 0

#property indicator_color2 Yellow
#property indicator_width2 0

//---- input parameters
extern int   BarsToSearch=500;   // ?????????? ????? ??? ???????
extern int   Lines=12;           // ?????????? ???????/????????? ??????????? ????? (max 100)
extern bool  FractalsTrue=true;  // ???/???? ??????? ?????????
extern bool  AlertTrue=false;     // ???/???? ???????
extern color LinesColorUp=Lime;  // ???? ??????? ??????????? ?????
extern color LinesColorDown=Red; // ???? ?????? ??????????? ?????

extern int widthUp1 =2;
extern int styleUp1 =0;

extern int widthUp2 =1;
extern int styleUp2 =2;

extern int widthDown1 =2;
extern int styleDown1 =0;

extern int widthDown2 =1;
extern int styleDown2 =2;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//--- my variables
double BufPriceUp[100];
double BufDateUp[100];
double BufPriceDown[100];
double BufDateDown[100];
datetime LastSignal = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   if(Lines>100) Lines=100;
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,217);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,218);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Fractals");
   SetIndexLabel(0,"FractalsUp");
   SetIndexLabel(1,"FractalsDown");
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
   for (int j=0; j<100; j++)
   {
      ObjectDelete("LineUp"+j);
      ObjectDelete("LineDown"+j);
   }
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int uplines=0;
   int downlines=0;
   int Up=0;
   int Down=0;
   bool l_n_exists;
   deinit();
//---- ???????? ????
   for (int i=0; i<BarsToSearch; i++)
   {
      if (FractalsTrue==true)
      {
         ExtMapBuffer1[i]=iFractals(NULL,0,MODE_UPPER,i);
         ExtMapBuffer2[i]=iFractals(NULL,0,MODE_LOWER,i);
      } 
//---- ???? Up-?????????
      double f = iFractals(NULL,0,MODE_UPPER,i);
      if (f!=0)
      {
         Up++;
         BufPriceUp[Up]=f;
         BufDateUp[Up]=Time[i];
         if (Up>2 && uplines<Lines && BufPriceUp[Up]>BufPriceUp[Up-1] && BufPriceUp[Up-1]>BufPriceUp[Up-2])
         {
            ObjectCreate("LineUp"+Up,OBJ_TREND,0,BufDateUp[Up],BufPriceUp[Up],BufDateUp[Up-1],BufPriceUp[Up-1]);
            l_n_exists = ObjectCreate("LineUp"+(Up-1),OBJ_TREND,0,BufDateUp[Up-1],BufPriceUp[Up-1],BufDateUp[Up-2],BufPriceUp[Up-2]);
            if (ObjectGetValueByShift("LineUp"+Up,0)>ObjectGetValueByShift("LineUp"+(Up-1),0))
            {
               ObjectDelete("LineUp"+Up);
               if(l_n_exists) ObjectDelete("LineUp"+(Up-1));
            }
            else
            {
               uplines+=2;
               if (AlertTrue==true && uplines==2 && LastSignal<Time[i])
               {
                  LastSignal = Time[i];
                  Alert(Symbol(),Period()," ?????????? ?????! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
               }
               ObjectSet("LineUp"+(Up-1),OBJPROP_COLOR,LinesColorUp);
               ObjectSet("LineUp"+(Up-1),OBJPROP_WIDTH,widthUp1);
               ObjectSet("LineUp"+(Up-1),OBJPROP_STYLE,styleUp1);
               ObjectSet("LineUp"+(Up-1),OBJPROP_RAY,True);
               ObjectSet("LineUp"+Up,OBJPROP_COLOR,LinesColorUp);
               ObjectSet("LineUp"+Up,OBJPROP_WIDTH,widthUp2);
               ObjectSet("LineUp"+Up,OBJPROP_STYLE,styleUp2);
               ObjectSet("LineUp"+Up,OBJPROP_RAY,True);         
            }
         } 
      }
//---- ???? Down-?????????
      f = iFractals(NULL,0,MODE_LOWER,i);
      if (f!=0)
      {
         Down++;
         BufPriceDown[Down]=f;
         BufDateDown[Down]=Time[i];
         if (Down>2 && downlines<Lines && BufPriceDown[Down]<BufPriceDown[Down-1] && BufPriceDown[Down-1]<BufPriceDown[Down-2])
         {
            ObjectCreate("LineDown"+Down,OBJ_TREND,0,BufDateDown[Down],BufPriceDown[Down],BufDateDown[Down-1],BufPriceDown[Down-1]);
            l_n_exists = ObjectCreate("LineDown"+(Down-1),OBJ_TREND,0,BufDateDown[Down-1],BufPriceDown[Down-1],BufDateDown[Down-2],BufPriceDown[Down-2]);
            if (ObjectGetValueByShift("LineDown"+Down,0)<ObjectGetValueByShift("LineDown"+(Down-1),0))
            {
               ObjectDelete("LineDown"+Down);
               if(l_n_exists) ObjectDelete("LineDown"+(Down-1));
            } 
            else
            {
               downlines+=2;
               if (AlertTrue==true && downlines==2 && LastSignal<Time[i])
               {
                  LastSignal = Time[i];
                  Alert(Symbol(),Period()," ?????????? ?????! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
               }
               ObjectSet("LineDown"+(Down-1),OBJPROP_COLOR,LinesColorDown);
               ObjectSet("LineDown"+(Down-1),OBJPROP_WIDTH,widthDown1);
               ObjectSet("LineDown"+(Down-1),OBJPROP_STYLE,styleDown1);
               ObjectSet("LineDown"+(Down-1),OBJPROP_RAY,True);
               ObjectSet("LineDown"+Down,OBJPROP_COLOR,LinesColorDown);
               ObjectSet("LineDown"+Down,OBJPROP_WIDTH,widthDown2);
               ObjectSet("LineDown"+Down,OBJPROP_STYLE,styleDown2);
               ObjectSet("LineDown"+Down,OBJPROP_RAY,True);
            }
         } 
      }
   }
//----
   return(0);
}
//+------------------------------------------------------------------+